diff --git a/libr/core/canal.c b/libr/core/canal.c
index 10bf9ec22e4..5a100818fd0 100644
--- a/libr/core/canal.c
+++ b/libr/core/canal.c
@@ -2992,21 +2992,17 @@ R_API int r_core_anal_fcn_list(RCore *core, const char *input, const char *rad)
 		break;
 	case '=': { // afl=
 		r_list_sort (fcns, cmpaddr);
-		RList *flist = r_list_new ();
+		RList *flist = r_list_newf ((RListFree) r_listinfo_free);
 		if (!flist) {
 			return -1;
 		}
 		ls_foreach (fcns, iter, fcn) {
 			char temp[4];
-			ListInfo *info = R_NEW (ListInfo);
+			RInterval inter = (RInterval) {fcn->addr, r_anal_fcn_size (fcn)};
+			RListInfo *info = r_listinfo_new (r_core_anal_fcn_name (core, fcn), inter, inter, -1, sdb_itoa (fcn->bits, temp, 10));
 			if (!info) {
-				return -1;
+				break;
 			}
-			info->name = r_core_anal_fcn_name (core, fcn);
-			info->pitv = (RInterval) {fcn->addr, r_anal_fcn_size (fcn)};
-			info->vitv = info->pitv;
-			info->extra = sdb_itoa (fcn->bits, temp, 10); 
-			info->perm  = -1;
 			r_list_append (flist, info);
 		}
 		r_core_visual_list (core, flist, core->offset, core->blocksize,
diff --git a/libr/core/cbin.c b/libr/core/cbin.c
index 4c1d985f71d..5980ee928f7 100644
--- a/libr/core/cbin.c
+++ b/libr/core/cbin.c
@@ -2375,23 +2375,20 @@ static int bin_sections(RCore *r, int mode, ut64 laddr, int va, ut64 at, const c
 	}
 	if (IS_MODE_EQUAL (mode)) {
 		int cols = r_cons_get_size (NULL);
-		RList *list = r_list_new ();
+		RList *list = r_list_newf ((RListFree) r_listinfo_free);
 		if (!list) {
 			return false;
 		}
 		RBinSection *s;
 		r_list_foreach (sections, iter, s) {
 			char humansz[8];
-			ListInfo *info = R_NEW (ListInfo);
+			RInterval pitv = (RInterval){s->paddr, s->size};
+			RInterval vitv = (RInterval){s->vaddr, s->vsize};
+			r_num_units (humansz, sizeof (humansz), s->size);
+			RListInfo *info = r_listinfo_new (s->name, pitv, vitv, s->perm, strdup (humansz));
 			if (!info) {
-				return false;
+				break;
 			}
-			info->name = s->name;
-			info->pitv = (RInterval){s->paddr, s->size};
-			info->vitv = (RInterval){s->vaddr, s->vsize};
-			info->perm = s->perm;
-			r_num_units (humansz, sizeof (humansz), s->size);
-			info->extra = strdup (humansz);
 			r_list_append (list, info);
 		}
 		r_core_visual_list (r, list, r->offset, -1, cols, r->print->flags & R_PRINT_FLAGS_COLOR);
diff --git a/libr/core/cmd_anal.c b/libr/core/cmd_anal.c
index d9b7edb8e6b..b5fc21e6b84 100644
--- a/libr/core/cmd_anal.c
+++ b/libr/core/cmd_anal.c
@@ -1884,20 +1884,16 @@ static bool anal_fcn_list_bb(RCore *core, const char *input, bool one) {
 	}
 	r_list_sort (fcn->bbs, bb_cmp);
 	if (mode == '=') { // afb
-		RList *flist = r_list_new ();
+		RList *flist = r_list_newf ((RListFree) r_listinfo_free);
 		if (!flist) {
 			return false;
 		}
 		ls_foreach (fcn->bbs, iter, b) {
-			ListInfo *info = R_NEW (ListInfo);
+			RInterval inter = (RInterval) {b->addr, b->size};
+			RListInfo *info = r_listinfo_new (b->label, inter, inter, -1, NULL);
 			if (!info) {
-				return false;
+				break;
 			}
-			info->name = b->label;
-			info->pitv = (RInterval) {b->addr, b->size};
-			info->vitv = info->pitv;
-			info->perm = -1;
-			info->extra = NULL;
 			r_list_append (flist, info);
 		}
 		r_core_visual_list (core, flist, core->offset, core->blocksize,
diff --git a/libr/core/cmd_open.c b/libr/core/cmd_open.c
index 83b253b4b65..a9a79d795ad 100644
--- a/libr/core/cmd_open.c
+++ b/libr/core/cmd_open.c
@@ -375,6 +375,28 @@ static void cmd_open_bin(RCore *core, const char *input) {
 			}
 		}
 		break;
+	case '=': // "ob="
+		{
+			RListIter *iter;
+			RList *list = r_list_newf ((RListFree) r_listinfo_free);
+			RBinFile *bf = NULL;
+			RBin *bin = core->bin;
+			if (!bin) {
+				return;
+			}
+			r_list_foreach (bin->binfiles, iter, bf) {
+				char temp[4];
+				RInterval inter = (RInterval) {bf->o->baddr, bf->o->size};
+				RListInfo *info = r_listinfo_new (bf->file, inter, inter, -1,  sdb_itoa (bf->fd, temp, 10));
+				if (!info) {
+					break;
+				}
+				r_list_append (list, info);
+			}
+			r_core_visual_list (core, list, core->offset, core->blocksize,
+				r_cons_get_size (NULL), r_config_get_i (core->config, "scr.color"));
+			r_list_free (list);
+		} break;
 	case '?': // "ob?"
 		r_core_cmd_help (core, help_msg_ob);
 		break;
@@ -771,7 +793,7 @@ static void cmd_open_map(RCore *core, const char *input) {
 		break;
 	case '=': // "om=" 
 		{
-		RList *list = r_list_new ();
+		RList *list = r_list_newf ((RListFree) r_listinfo_free);
 		if (!list) {
 			return;
 		}
@@ -779,15 +801,10 @@ static void cmd_open_map(RCore *core, const char *input) {
 		RIOMap *map;
 		ls_foreach_prev (core->io->maps, iter, map) {
 			char temp[4];
-			ListInfo *info = R_NEW (ListInfo);
+			RListInfo *info = r_listinfo_new (map->name, map->itv, map->itv, map->perm, sdb_itoa (map->fd, temp, 10));
 			if (!info) {
-				return;
+				break;
 			}
-			info->name = map->name;
-			info->pitv = map->itv;
-			info->vitv = map->itv;
-			info->perm = map->perm;
-			info->extra = sdb_itoa (map->fd, temp, 10);
 			r_list_append (list, info);
 		}
 		r_core_visual_list (core, list, core->offset, core->blocksize,
diff --git a/libr/core/visual.c b/libr/core/visual.c
index 140da856c6b..238d0310fe2 100644
--- a/libr/core/visual.c
+++ b/libr/core/visual.c
@@ -4290,11 +4290,31 @@ R_API int r_core_visual(RCore *core, const char *input) {
 	return 0;
 }
 
+R_API RListInfo *r_listinfo_new(char *name, RInterval pitv, RInterval vitv, int perm, char *extra) {
+	RListInfo *info = R_NEW (RListInfo);
+	if (!info) {
+		return NULL;
+	}
+	info->name = name;
+	info->pitv = pitv;
+	info->vitv = vitv;
+	info->perm = perm;
+	info->extra = extra;
+	return info;
+}
+
+R_API void r_listinfo_free (RListInfo *info) {
+	if (!info) {
+		return;
+	}
+	R_FREE (info);
+}
+
 // TODO: move this to the table api
 R_API void r_core_visual_list(RCore *core, RList *list, ut64 seek, ut64 len, int width, int use_color) {
 	ut64 mul, min = -1, max = -1;
 	RListIter *iter;
-	ListInfo *info;
+	RListInfo *info;
 	int j, i;
 	RIO *io = core->io;
 	width -= 80;
diff --git a/libr/debug/trace.c b/libr/debug/trace.c
index 91642a61218..8c430208e05 100644
--- a/libr/debug/trace.c
+++ b/libr/debug/trace.c
@@ -103,10 +103,10 @@ typedef struct {
 	RInterval vitv;
 	int perm;
 	char *extra;
-} ListInfo;
+} RListInfo;
 
 static int cmpaddr (const void *_a, const void *_b) {
-	const ListInfo *a = _a, *b = _b;
+	const RListInfo *a = _a, *b = _b;
 	return (r_itv_begin (a->pitv) > r_itv_begin (b->pitv))? 1:
 		 (r_itv_begin (a->pitv) < r_itv_begin (b->pitv))? -1: 0;
 }
@@ -115,7 +115,7 @@ static int cmpaddr (const void *_a, const void *_b) {
 void visual_list(RDebug *dbg, RList *list, ut64 seek, ut64 len, int width, int use_color) {
 	ut64 mul, min = -1, max = -1;
 	RListIter *iter;
-	ListInfo *info;
+	RListInfo *info;
 	int j, i;
 	RIO *io = dbg->iob.io;
 	width -= 80;
@@ -218,7 +218,7 @@ R_API void r_debug_trace_list (RDebug *dbg, int mode, ut64 offset) {
 				dbg->cb_printf ("0x%"PFMT64x"\n", trace->addr);
 				break;
 			case '=': {
-				ListInfo *info = R_NEW0 (ListInfo);
+				RListInfo *info = R_NEW0 (RListInfo);
 				if (!info) {
 					return;
 				}
diff --git a/libr/include/r_core.h b/libr/include/r_core.h
index e5630b3d77c..948cfe2c3a8 100644
--- a/libr/include/r_core.h
+++ b/libr/include/r_core.h
@@ -342,7 +342,7 @@ typedef struct {
 	RInterval vitv;
 	int perm;
 	char *extra;
-} ListInfo;
+} RListInfo;
 
 #ifdef R_API
 //#define r_core_ncast(x) (RCore*)(size_t)(x)
@@ -440,6 +440,8 @@ R_API void r_core_anal_esil_graph(RCore *core, const char *expr);
 
 R_API void r_core_list_io(RCore *core);
 R_API void r_core_visual_list(RCore *core, RList* list, ut64 seek, ut64 len, int width, int use_color);
+R_API RListInfo *r_listinfo_new (char *name, RInterval pitv, RInterval vitv, int perm, char *extra);
+R_API void r_listinfo_free (RListInfo *info);
 /* visual marks */
 R_API void r_core_visual_mark_seek(RCore *core, ut8 ch);
 R_API void r_core_visual_mark(RCore *core, ut8 ch);
